--------------------------------------------------------------------------------
-- Weapon super bazooka 
-- Script by Thecode
--------------------------------------------------------------------------------

-- Setup Tables
if thecode==nil then thecode={} end
thecode.superbazooka={}
thecode.superbazooka.rocketbig={}
thecode.superbazooka.rocketsmall={}
thecode.superbazooka.rocketsmall2={}

-- Load & Prepare Ressources
thecode.superbazooka.gfx_wpn=loadgfx("weapons/launcherbig.png")					-- Weapon Image
setmidhandle(thecode.superbazooka.gfx_wpn)
thecode.superbazooka.gfx_pro=loadgfx("weapons/rocketbig.png")					-- Projectile Image
setmidhandle(thecode.superbazooka.gfx_pro)
thecode.superbazooka.gfx_prosmall=loadgfx("weapons/rocket.bmp")	
setmidhandle(thecode.superbazooka.gfx_prosmall)
thecode.superbazooka.sfx_attack=loadsfx("rocketbigrelease.wav")					-- Attack Sound

--------------------------------------------------------------------------------
-- Weapon: superbazooka
--------------------------------------------------------------------------------

thecode.superbazooka.id=addweapon("thecode.superbazooka","Super superbazooka",thecode.superbazooka.gfx_pro)	-- Add Weapon
thecode.superbazooka.ammo=2

function thecode.superbazooka.draw()											-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(thecode.superbazooka.gfx_wpn,6,0)
	-- HUD chargebar
	if weapon_charge>0 and weapon_shots==0 then
		hudchargebar(weapon_charge,100)
	end
	-- HUD Crosshair
	if weapon_shots==0 then
		hudcrosshair(6,3)
	end
end

function thecode.superbazooka.attack(attack)									-- Attack

	if (weapon_shots<=0) then
	weapon_timer=30
		-- Charge
		if (attack==1) then
			weapon_charge=weapon_charge+1							-- Increase charge
		end
		-- Fire a projectile (on release/full charge)
		if (attack==0 and weapon_charge>0) or (weapon_charge>=100) then
			-- No more weapon switching!
			useweapon(0)
			playsound(thecode.superbazooka.sfx_attack)
			weapon_shots=weapon_shots+1
			id=createprojectile(thecode.superbazooka.rocketbig.id)
			projectiles[id]={}
			-- Ignore collision with current player at beginning
			projectiles[id].ignore=playercurrent()
			-- Set initial position of projectile
			projectiles[id].x=getplayerx(0)+(6*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*10.0
			projectiles[id].y=getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*10.0
			-- Initial movement
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*20
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*20
			projectiles[id].x=projectiles[id].x-projectiles[id].sx
			projectiles[id].y=projectiles[id].y-projectiles[id].sy
			thecode.superbazooka.rocketbig.move(id,0)
			-- Set speed of projectile
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*(weapon_charge/100.0)*10.0
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*(weapon_charge/100.0)*10.0
			-- Effects
			recoil(2)
			-- End Turn
			endturn()
		end
	end
end


--------------------------------------------------------------------------------
-- Projectile: rocketbig
--------------------------------------------------------------------------------

thecode.superbazooka.rocketbig.id=addprojectile("thecode.superbazooka.rocketbig")		-- Add Projectile

function thecode.superbazooka.rocketbig.draw(id)							-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(thecode.superbazooka.gfx_pro,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function thecode.superbazooka.rocketbig.update(id)						-- Update
	-- Move
	thecode.superbazooka.rocketbig.move(id,1)
end

function thecode.superbazooka.rocketbig.move(id,fx)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Particle Tail
	if (fx==1) then
		particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
		particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
		particlefadealpha(0.01)
		particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
		particlefadealpha(0.04)
	end
	
	
	-- Wind + Gravity influence on speed
	projectiles[id].sx=projectiles[id].sx+getwind()
	projectiles[id].sy=projectiles[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
			-- Spawn small rocket
		math.randomseed(projectiles[id].x*3+projectiles[id].y)
		for i=1,5,1 do
			pid=createprojectile(thecode.superbazooka.rocketsmall.id)
			projectiles[pid]={}
			projectiles[pid].x=projectiles[id].x+math.random(-30,40)*0.1
			projectiles[pid].y=projectiles[id].y+math.random(-30,-20)*0.1
			projectiles[pid].sx=math.random(-40,40)*0.1
			projectiles[pid].sy=math.random(-50,-10)*0.1
			if i==0 then projectiles[pid].follow=1 end
		end
				-- Cause damage
				arealdamage(projectiles[id].x,projectiles[id].y,150,150)
				-- Destroy terrain
				terrainexplosion(projectiles[id].x,projectiles[id].y,150,1)
				-- Crater
				grey=math.random(0,40)
				if math.random(0,1)==1 then
					terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				else
					terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				end
				-- Free projectile
				freeprojectile(id)
				return 1
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
		-- Spawn small rocket
		math.randomseed(projectiles[id].x*3+projectiles[id].y)
		for i=1,5,1 do
			pid=createprojectile(thecode.superbazooka.rocketsmall.id)
			projectiles[pid]={}
			projectiles[pid].x=projectiles[id].x+math.random(-30,40)*0.1
			projectiles[pid].y=projectiles[id].y+math.random(-30,-20)*0.1
			projectiles[pid].sx=math.random(-40,40)*0.1
			projectiles[pid].sy=math.random(-50,-10)*0.1
			if i==0 then projectiles[pid].follow=1 end
		end
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			return 1
		end
	end
	-- Scroll to projectile
	scroll(projectiles[id].x,projectiles[id].y)
end

--------------------------------------------------------------------------------
-- Projectile: rocketsmall
--------------------------------------------------------------------------------

thecode.superbazooka.rocketsmall.id=addprojectile("thecode.superbazooka.rocketsmall")		-- Add Projectile

function thecode.superbazooka.rocketsmall.draw(id)							-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(thecode.superbazooka.gfx_pro,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function thecode.superbazooka.rocketsmall.update(id)						-- Update
	-- Move
	thecode.superbazooka.rocketsmall.move(id,1)
end

function thecode.superbazooka.rocketsmall.move(id,fx)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Particle Tail
	if (fx==1) then
		particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
		particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
		particlefadealpha(0.01)
		particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
		particlefadealpha(0.04)
	end
	-- Wind + Gravity influence on speed
	projectiles[id].sx=projectiles[id].sx+getwind()
	projectiles[id].sy=projectiles[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
			-- Spawn small rocket
		math.randomseed(projectiles[id].x*3+projectiles[id].y)
		for i=1,5,1 do
			pid=createprojectile(thecode.superbazooka.rocketsmall2.id)
			projectiles[pid]={}
			projectiles[pid].x=projectiles[id].x+math.random(-30,40)*0.1
			projectiles[pid].y=projectiles[id].y+math.random(-30,-20)*0.1
			projectiles[pid].sx=math.random(-40,40)*0.1
			projectiles[pid].sy=math.random(-50,-10)*0.1
			if i==0 then projectiles[pid].follow=1 end
		end
				-- Cause damage
				arealdamage(projectiles[id].x,projectiles[id].y,30,30)
				-- Destroy terrain
				terrainexplosion(projectiles[id].x,projectiles[id].y,10,1)
				-- Crater
				grey=math.random(0,40)
				if math.random(0,1)==1 then
					terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				else
					terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				end
				-- Free projectile
				freeprojectile(id)
				return 1
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			return 1
		end
	end
	-- Scroll to projectile
	scroll(projectiles[id].x,projectiles[id].y)
end


--------------------------------------------------------------------------------
-- Projectile: rocketsmall2
--------------------------------------------------------------------------------

thecode.superbazooka.rocketsmall2.id=addprojectile("thecode.superbazooka.rocketsmall2")		-- Add Projectile

function thecode.superbazooka.rocketsmall2.draw(id)							-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(thecode.superbazooka.gfx_prosmall,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function thecode.superbazooka.rocketsmall2.update(id)						-- Update
	-- Move
	thecode.superbazooka.rocketsmall2.move(id,1)
end

function thecode.superbazooka.rocketsmall2.move(id,fx)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Particle Tail
	if (fx==1) then
		particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
		particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
		particlefadealpha(0.01)
		particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
		particlefadealpha(0.04)
	end
	-- Wind + Gravity influence on speed
	projectiles[id].sx=projectiles[id].sx+getwind()
	projectiles[id].sy=projectiles[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				-- Cause damage
				arealdamage(projectiles[id].x,projectiles[id].y,30,30)
				-- Destroy terrain
				terrainexplosion(projectiles[id].x,projectiles[id].y,10,1)
				-- Crater
				grey=math.random(0,40)
				if math.random(0,1)==1 then
					terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				else
					terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				end
				-- Free projectile
				freeprojectile(id)
				return 1
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			return 1
		end
	end
	-- Scroll to projectile
	scroll(projectiles[id].x,projectiles[id].y)
end