--------------------------------------------------------------------------------
-- Weapon firegun + Projectile liana

-- Script by Thecode,September 2010.
--------------------------------------------------------------------------------

-- Setup Tables
if thecode==nil then thecode={} end
thecode.liana={}
thecode.liana.liana={}

-- Load & Prepare Ressources
thecode.liana.gfx_wpn=loadgfx("weapons/liana.png")					-- Weapon Image
setmidhandle(thecode.liana.gfx_wpn)
thecode.liana.gfx_pro=loadgfx("weapons/liana.png")					-- Projectile Image
setmidhandle(thecode.liana.gfx_pro)
thecode.liana.gfx_pro2=loadgfx("weapons/lianacord.png")					-- Projectile Image
setmidhandle(thecode.liana.gfx_pro2)
thecode.liana.sfx_attack=loadsfx("arrow_shoot.ogg")					-- Attack Sound
thecode.liana.sfx_impact=loadsfx("buildstone.ogg")
thecode.liana.sfx_jump=loadsfx("swish.ogg")
--------------------------------------------------------------------------------
-- Weapon: liana
--------------------------------------------------------------------------------

thecode.liana.id=addweapon("thecode.liana","Liana",thecode.liana.gfx_pro)	-- Add Weapon

function thecode.liana.draw()											-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(thecode.liana.gfx_wpn,6,0)
	-- HUD Crosshair
	if weapon_shots==0 then
		hudcrosshair(6,3)
	end
end

function thecode.liana.attack(attack)									-- Attack
if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	
	if (weapon_shots<=0) then
	useweapon(1)
	
		-- Charge
		if (attack==1) then
			weapon_charge=weapon_charge+1							-- Increase charge
		end
		
		
	-- Reset Timer
		weapon_timer=50
		-- liana a projectile (on release/full charge)
		if (attack==0 and weapon_charge>0) or (weapon_charge>=100) then
			-- No more weapon switching!
			scroll(getplayerx(0),getplayery(0))
			playsound(thecode.liana.sfx_attack)
			weapon_shots=weapon_shots+1
			id=createprojectile(thecode.liana.liana.id)
			projectiles[id]={}
			-- Ignore collision with current player at beginning
			projectiles[id].ignore=playercurrent()
			-- Set initial position of projectile
			projectiles[id].x=getplayerx(0)+(6*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*10.0
			projectiles[id].y=getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*10.0
			-- Initial movement
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*20
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*20
			projectiles[id].x=projectiles[id].x-projectiles[id].sx
			projectiles[id].y=projectiles[id].y-projectiles[id].sy
			thecode.liana.liana.move(id,0)
			-- Set speed of projectile
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*10.0
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*10.0
			
			-- Timeout (disable stick)
		-- Set timer
			projectiles[id].timer=5

			-- Effects
			recoil(2)
			-- End Turn
			
		end
	end
end

--------------------------------------------------------------------------------
-- Projectile: liana
--------------------------------------------------------------------------------

thecode.liana.liana.id=addprojectile("thecode.liana.liana")		-- Add Projectile

function thecode.liana.liana.draw(id)							-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(thecode.liana.gfx_pro,projectiles[id].x,projectiles[id].y)
	
	setblend(blend_light)
		setcolor(250,250,0)
		setscale(1,-10)
		setrotation(getplayerrotation(0))
	drawline(getplayerx(0), getplayery(0), projectiles[id].x,projectiles[id].y, 4)
				
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function thecode.liana.liana.update(id)						-- Update
	-- Move
	thecode.liana.liana.move(id,1)
end

function thecode.liana.liana.move(id,fx)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Wind + Gravity influence on speed
	
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	if weapon_timer<=0 then
	-- Free projectile
				freeprojectile(id)
				end
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3,1,1)==1 then
		
			if terraincollision()==1 then 
			playsound(thecode.liana.sfx_impact)
			
			playsound(thecode.liana.sfx_jump)
				if getplayerdirection(0)==1 then
			playerpush(0,math.sin(math.rad(getplayerrotation(0)))*10.0,-math.cos(math.rad(getplayerrotation(0)))*20.0,1,0)
			elseif getplayerdirection(0)==-1 then
			playerpush(0,math.sin(math.rad(getplayerrotation(0)))*10.0,-math.cos(math.rad(getplayerrotation(0)))*20.0,1,0)
			end
			-- Draw  in terrain
					terrainimage(thecode.liana.gfx_pro,projectiles[id].x,projectiles[id].y,0,rot)
				
			-- Avoid Falldamage
		if getplayeryspeed(0)>7.0 then
			playerpush(0,getplayerxspeed(0),7.0,1,0)
		end
		
		
				-- Free projectile
				freeprojectile(id)
				return 1
			end
			
			
			if  playercollision()~=projectiles[id].ignore then
			playsound(thecode.liana.sfx_jump)
			playerdamage(playercollision(),20+math.random(0,30))
				if getplayerdirection(0)==1 then
			playerpush(0,math.sin(math.rad(getplayerrotation(0)))*10.0,-math.cos(math.rad(getplayerrotation(0)))*20.0,1,0)
			elseif getplayerdirection(0)==-1 then
			playerpush(0,math.sin(math.rad(getplayerrotation(0)))*10.0,-math.cos(math.rad(getplayerrotation(0)))*20.0,1,0)
			end
			-- Draw  in terrain
					terrainimage(thecode.liana.gfx_pro,projectiles[id].x,projectiles[id].y,0,rot)
				
			-- Avoid Falldamage
		if getplayeryspeed(0)>7.0 then
			playerpush(0,getplayerxspeed(0),7.0,1,0)
		end
		
		
				-- Free projectile
				freeprojectile(id)
			
			end
			
			
			
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			return 1
		end
	end
	-- Scroll to projectile
	scroll(projectiles[id].x,projectiles[id].y)
	
end